// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#include "EntitySwordAttack.hpp"

using namespace Dawn;

EntitySwordAttack::EntitySwordAttack(SceneItem* item) : EntityAttackBase(item) {
}

void EntitySwordAttack::onStart() {
  EntityAttackBase::onStart();

  useEvent([&]{
  }, this->onAttackRampUpStart);

  useEvent([&]{
  }, this->onAttackRampUpEnd);

  useEvent([&]{
  }, this->onAttackActiveStart);

  useEvent([&]{
  }, this->onAttackActiveEnd);

  useEvent([&]{
  }, this->onAttackRampDownStart);

  useEvent([&]{
  }, this->onAttackRampDownEnd);

  useEvent([&]{
  }, this->onAttackCooldownStart);

  useEvent([&]{
  }, this->onAttackCooldownEnd);

  useEvent([&]{
  }, this->onAttackInterrupted);
}

float_t EntitySwordAttack::getAttackRampUpDuration() {
  return 0.1f;
}

float_t EntitySwordAttack::getAttackActiveDuration() {
  return 0.2f;
}

float_t EntitySwordAttack::getAttackRampDownDuration() {
  return 0.1f;
}

float_t EntitySwordAttack::getAttackCooldownDuration() {
  return 0.0f;
}

bool_t EntitySwordAttack::isInterruptable() {
  return false;
}

bool_t EntitySwordAttack::canAttack() {
  return true;
}